;; Visiting is really some kind of a structural mapping:
(defgeneric map-object (func object)
  (:method (func object) (funcall func  object)))


(defclass wheel () ())

(defclass body ()
  ((wheels :initform (loop :for i :from 1 :upto 4
			   :for wheel = (make-instance 'wheel)
			   :collect wheel)
	   :accessor wheels)))

(defmethod map-object (func (body body))
  (funcall func body)
  (dolist (wheel (wheels body))
    (map-object func wheel)))

(defclass engine () ())

(defclass porshe ()
  ((engine :initform (make-instance 'engine)
	   :accessor engine)
   (body :initform (make-instance 'body)
	 :accessor body)))

(defmethod map-object (func (porshe porshe))
  (funcall func porshe)
  (map-object func (engine porshe))
  (map-object func (body porshe)))

(defgeneric paint (object)
  (:method ((wheel wheel))
    (format t "Painting a wheel.~%"))
  (:method ((body body))
    (format t "Painting the body.~%"))
  (:method ((engine engine))
    (format t "Painting the engine.~%"))
  (:method ((porshe porshe))
    (format t "Painting the Porshe.~%")))

(defgeneric recycle (object)
  (:method ((wheel wheel))
    (format t "Recycling a wheel.~%"))
  (:method ((body body))
    (format t "Recycling the body.~%"))
  (:method ((engine engine))
    (format t "Recycling the engine.~%"))
  (:method ((porshe porshe))
    (format t "Recycling the Porshe.~%")))


(defun main ()
  (let ((porshe (make-instance 'porshe)))
    (map-object #'paint porshe)
    (map-object #'recycle porshe))
  (quit))
